SystemOrganization addCategory: #'ImageWriter-Core'!

Object subclass: #HzCogImageFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageWriter-Core'!

!HzCogImageFormat methodsFor: 'header' stamp: 'GuillermoPolito 4/23/2012 16:22'!
flagInterpretedMethods
	^false! !

!HzCogImageFormat methodsFor: 'header' stamp: 'GuillermoPolito 4/23/2012 16:49'!
imageHeaderFlags
	"Answer the flags that are contained in the 7th long of the image header."
	^ (self isFullScreenFlag                ifTrue: [0] ifFalse: [1]) "0 or 1"
	+ (self isBigEndianVM                  ifTrue: [0] ifFalse: [2]) "this is the imageFloatsLittleEndian flag"
	+ (self processHasThreadId        ifTrue: [4] ifFalse: [0])
	+ (self flagInterpretedMethods   ifTrue: [8] ifFalse: [0])
	+ (self preemptionYields             ifTrue: [0] ifFalse: [16])
	+ (self noThreadingOfGUIThread ifTrue: [32] ifFalse: [0])! !

!HzCogImageFormat methodsFor: 'header' stamp: 'GuillermoPolito 4/23/2012 15:54'!
imageHeaderSize

	^ 64  "bytes"! !

!HzCogImageFormat methodsFor: 'header' stamp: 'GuillermoPolito 4/25/2012 13:03'!
isBigEndianVM
	^false! !

!HzCogImageFormat methodsFor: 'header' stamp: 'GuillermoPolito 4/24/2012 16:43'!
isFullScreenFlag
	^true! !

!HzCogImageFormat methodsFor: 'header' stamp: 'GuillermoPolito 4/23/2012 15:54'!
lastHash
	^ Object new basicIdentityHash! !

!HzCogImageFormat methodsFor: 'header' stamp: 'GuillermoPolito 4/23/2012 16:22'!
noThreadingOfGUIThread
	^false! !

!HzCogImageFormat methodsFor: 'accessing' stamp: 'GuillermoPolito 4/23/2012 15:54'!
objectMemoryStart
	^self imageHeaderSize! !

!HzCogImageFormat methodsFor: 'header' stamp: 'GuillermoPolito 4/23/2012 16:22'!
preemptionYields
	^false! !

!HzCogImageFormat methodsFor: 'header' stamp: 'GuillermoPolito 4/23/2012 16:21'!
processHasThreadId
	^false! !

!HzCogImageFormat methodsFor: 'header' stamp: 'GuillermoPolito 4/23/2012 16:00'!
versionNumber
	^6505! !

!HzCogImageFormat methodsFor: 'accessing' stamp: 'GuillermoPolito 4/23/2012 15:54'!
wordSize
	^4 "bytes.  We support 32 bit platforms only"! !

!HzCogImageFormat methodsFor: 'writing' stamp: 'GuillermoPolito 4/23/2012 16:51'!
writeImageHeaderOn: byteStream forWriter: aWriter
	| nextPutLong buffer |
	buffer := WordArray new: 1.
	nextPutLong := [ :number | byteStream nextPutAll: (buffer at: 1 put: number; yourself) ].
	
	nextPutLong value: self versionNumber.
	nextPutLong value: self imageHeaderSize.
	nextPutLong value: aWriter finalSize - self imageHeaderSize.
	nextPutLong value: self imageHeaderSize.  "start of memory"
	nextPutLong value: aWriter specialObjectsOop.
	nextPutLong value: self lastHash.
	nextPutLong value: Display boundingBox width * 16r10000 + Display boundingBox height.
	nextPutLong value: self imageHeaderFlags.
	nextPutLong value: Smalltalk vm extraVMMemory.
	nextPutLong value: (((Smalltalk vm parameterAt: 43) bitShift: 16) + (Smalltalk vm parameterAt: 47)).
	nextPutLong value: (Smalltalk vm parameterAt: 45).
	nextPutLong value: ((Smalltalk vm parameterAt: 49) bitShift: 16).
	byteStream padTo: self imageHeaderSize put: 0.
! !

Object subclass: #HzImageWriter
	instanceVariableNames: 'theImageFileName imageToWrite closureEnsurer specialObjectsArray oopMap traceQueue byteStream nextChunk displayBox swapMap imageFormat initializationBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageWriter-Core'!

!HzImageWriter methodsFor: 'testing' stamp: 'GuillermoPolito 4/26/2012 12:23'!
areWeInClone
	^byteStream isNil! !

!HzImageWriter methodsFor: 'run' stamp: 'GuillermoPolito 4/26/2012 12:23'!
basicWriteImage
	| contextCopy |
	"we make the executing context restart from out of here so it gets initialized"
	contextCopy := thisContext copy.
	contextCopy push: nil.
	swapMap 
		at: Processor activeProcess 
		put: (Process forContext: contextCopy sender priority: Processor activePriority).

	"and we write the image!!"
	[
		nextChunk := imageFormat objectMemoryStart.
		Smalltalk garbageCollect.
		self traceImage.
		self writeFileHeader.
	] ensure: [ 
		self closeImageFile.
	].
! !

!HzImageWriter methodsFor: 'private' stamp: 'GuillermoPolito 4/26/2012 12:23'!
closeImageFile
	byteStream close.! !

!HzImageWriter methodsFor: 'object replacement' stamp: 'GuillermoPolito 4/26/2012 12:23'!
convert: obj pointer: pointer field: index
	"fix for named primitives cache"
	^swapMap at: obj ifAbsent: [ obj ]! !

!HzImageWriter methodsFor: 'private' stamp: 'GuillermoPolito 4/26/2012 12:23'!
copyChangesFile
	(SourceFiles at: 2) ifNotNil:[
		SmalltalkImage current saveChangesInFileNamed: (SmalltalkImage current fullNameForChangesNamed: self imageFileName)].! !

!HzImageWriter methodsFor: 'accessing' stamp: 'GuillermoPolito 4/26/2012 12:23'!
finalSize
	^nextChunk! !

!HzImageWriter methodsFor: 'accessing' stamp: 'GuillermoPolito 4/26/2012 12:23'!
format
	^imageFormat! !

!HzImageWriter methodsFor: 'accessing' stamp: 'GuillermoPolito 4/26/2012 12:23'!
format: anImageFormat
	imageFormat := anImageFormat.! !

!HzImageWriter methodsFor: 'accessing' stamp: 'GuillermoPolito 4/26/2012 12:23'!
imageFileName
	^theImageFileName! !

!HzImageWriter methodsFor: 'accessing' stamp: 'GuillermoPolito 4/26/2012 12:23'!
imageFileName: imageFileName
	theImageFileName := imageFileName.! !

!HzImageWriter methodsFor: 'initialize-release' stamp: 'GuillermoPolito 4/26/2012 12:23'!
initialize
	super initialize.
	oopMap := IdentityDictionary new.
	traceQueue := OrderedCollection new.
	initializationBlock := [].
	self initializeSwapMap.! !

!HzImageWriter methodsFor: 'initialize-release' stamp: 'GuillermoPolito 4/26/2012 12:23'!
initializeNewImageFile
	byteStream := FileStream newFileNamed: self imageFileName.
	byteStream binary.! !

!HzImageWriter methodsFor: 'initialize-release' stamp: 'GuillermoPolito 4/26/2012 12:23'!
initializeSwapMap
	swapMap := IdentityDictionary new: 4000.
	swapMap at: self put: self class basicNew.! !

!HzImageWriter methodsFor: 'oop resolution' stamp: 'GuillermoPolito 4/26/2012 12:23'!
integerOopOf: value
	value < 0
		ifTrue: [^ ((16r80000000 + value) << 1) + 1]
		ifFalse: [^ (value << 1) + 1]! !

!HzImageWriter methodsFor: 'accessing' stamp: 'GuillermoPolito 4/26/2012 12:23'!
onInitializeDo: aBlock
	initializationBlock := aBlock! !

!HzImageWriter methodsFor: 'oop resolution' stamp: 'GuillermoPolito 4/26/2012 12:23'!
oopForObject: anObject
	anObject class = SmallInteger ifTrue: [^ self integerOopOf: anObject ].
	^oopMap at: (swapMap at: anObject ifAbsent: [anObject])! !

!HzImageWriter methodsFor: 'reserving' stamp: 'GuillermoPolito 4/26/2012 12:23'!
reserve: object
	"Add object to write queue and return its oop"
	| oop theFormat |
	
	theFormat := HzObjectFormat for: object withOopProvider: self withFormat: imageFormat.
	
	oop := nextChunk + ((theFormat ammountOfHeaders - 1) * imageFormat wordSize).
	nextChunk := oop + (theFormat bodyLength * imageFormat wordSize).

	"Add object to fill queue and remember its oop"
	oopMap at: object put: oop.
	traceQueue addLast: object.
	^ oop! !

!HzImageWriter methodsFor: 'reserving' stamp: 'GuillermoPolito 4/26/2012 12:23'!
reserve: obj from: pointer field: index
	"Add obj to write queue and return its oop"

	| object |
	obj class = SmallInteger ifTrue: [^ self integerOopOf: obj].

	"Return oop if already visited obj"
	object := self convert: obj pointer: pointer field: index.
	oopMap at: object ifPresent: [:itsOop | ^ itsOop].

	^ self reserve: object! !

!HzImageWriter methodsFor: 'private' stamp: 'GuillermoPolito 4/26/2012 12:23'!
specialObjectsArray
	^specialObjectsArray ifNil: [ specialObjectsArray := imageToWrite newSpecialObjectsArray ]! !

!HzImageWriter methodsFor: 'accessing' stamp: 'GuillermoPolito 4/26/2012 12:23'!
specialObjectsOop
	^oopMap at: self specialObjectsArray! !

!HzImageWriter methodsFor: 'object replacement' stamp: 'GuillermoPolito 5/3/2012 11:16'!
substitute: anObject by: anotherObject
	^swapMap at: anObject put: anotherObject! !

!HzImageWriter methodsFor: 'writing' stamp: 'GuillermoPolito 4/26/2012 12:23'!
traceImage
	"Trace image starting with true, false, nil, and specialObjectsArray"

	"Add true and false in front so the VM can assume it will never move (see Interpreter>>interpret)"
	self reserve: nil.
	self reserve: false.
	self reserve: true.
	self reserve: self specialObjectsArray.	
	
	"Write and trace rest of image"
	[traceQueue isEmpty] whileFalse: [
		self writeAndTrace: traceQueue removeFirst.
	].
! !

!HzImageWriter methodsFor: 'writing' stamp: 'GuillermoPolito 4/26/2012 12:23'!
writeAndTrace: object
	"Write the image representation of me on byteStream at my oop, and add my not-yet-seen fields to traceQueue."

	| oop  objectFormat |
	oop := oopMap at: object ifAbsent: [self error: object printString, ' has not oop assigned'].
	objectFormat := HzObjectFormat for: object withOopProvider: self withFormat: imageFormat.
	
	self reserve: object class from: object field: -1.
	self writeObjectHeaderOf: objectFormat.
	self writeFieldsFor: objectFormat.

	"Double check that fields take up expected size"
	byteStream position = (oop + (objectFormat bodyLength * imageFormat wordSize)) ifFalse: [
		self error: 'object size discrepency'].
	^ oop! !

!HzImageWriter methodsFor: 'writing' stamp: 'GuillermoPolito 4/26/2012 12:23'!
writeFieldsFor: theFormat
	theFormat indexedFields withIndexDo: [:val :i | self reserve: val from: theFormat realObject field: i].
	theFormat writeOn: byteStream withOopProvider: self.! !

!HzImageWriter methodsFor: 'writing' stamp: 'GuillermoPolito 4/26/2012 12:23'!
writeFileHeader
	byteStream position: 0.
	imageFormat
		writeImageHeaderOn: byteStream
		forWriter: self.! !

!HzImageWriter methodsFor: 'run' stamp: 'GuillermoPolito 4/26/2012 12:23'!
writeImage: aSmalltalkImage
	| initializationBlockCopy |
	imageToWrite := aSmalltalkImage.
	
	self initializeNewImageFile.
	self copyChangesFile.

	"We copy the initialization block because we want to access it after copying the image :)"
	initializationBlockCopy := initializationBlock copy.	

	Smalltalk shutDownImage: true.
	[self basicWriteImage] ensure:
		[
		Smalltalk startupImage: self areWeInClone snapshotWorked:  true.
		self areWeInClone ifTrue: initializationBlockCopy.
		]! !

!HzImageWriter methodsFor: 'writing' stamp: 'GuillermoPolito 4/26/2012 12:23'!
writeObjectHeaderOf: objectFormat
	"Write header"
	byteStream position: objectFormat oop - ((objectFormat ammountOfHeaders - 1) * imageFormat wordSize).
	byteStream nextPutAll: ((objectFormat headers collect: [ :h | h valueFor: self ]) asWordArray).! !

Object subclass: #HzInterpreterImageFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageWriter-Core'!

!HzInterpreterImageFormat methodsFor: 'header' stamp: 'GuillermoPolito 4/20/2012 18:50'!
hasBlockClosureSupport
	"true if this image has proper blockclosure support"
	
	| bc |
	[bc := [:b :e | e > 1
		ifFalse: [b value: bc value: e + 1]
		ifTrue: [e]].
	bc value: bc value: 1.
	^true]
		on: Error
		do: [^false]! !

!HzInterpreterImageFormat methodsFor: 'header' stamp: 'GuillermoPolito 4/20/2012 18:47'!
imageHeaderSize

	^ 64  "bytes"! !

!HzInterpreterImageFormat methodsFor: 'header' stamp: 'GuillermoPolito 4/20/2012 18:46'!
lastHash
	^ Object new basicIdentityHash! !

!HzInterpreterImageFormat methodsFor: 'accessing' stamp: 'GuillermoPolito 4/20/2012 18:55'!
objectMemoryStart
	^self imageHeaderSize! !

!HzInterpreterImageFormat methodsFor: 'header' stamp: 'GuillermoPolito 4/20/2012 18:47'!
versionNumber
	"Image format version number"

	self hasBlockClosureSupport
		ifTrue: [^6504]
		ifFalse: [^6502]! !

!HzInterpreterImageFormat methodsFor: 'accessing' stamp: 'GuillermoPolito 4/20/2012 19:01'!
wordSize
	^4 "bytes.  We support 32 bit platforms only"! !

!HzInterpreterImageFormat methodsFor: 'writing' stamp: 'GuillermoPolito 4/23/2012 12:59'!
writeImageHeaderOn: byteStream forWriter: aWriter
	| nextPutLong buffer |
	buffer := WordArray new: 1.
	nextPutLong := [ :number | byteStream nextPutAll: (buffer at: 1 put: number; yourself) ].
	
	nextPutLong value: self versionNumber.
	nextPutLong value: self imageHeaderSize.
	nextPutLong value: aWriter finalSize - self imageHeaderSize.
	nextPutLong value: self imageHeaderSize.  "start of memory"
	nextPutLong value: aWriter specialObjectsOop.
	nextPutLong value: self lastHash.
	nextPutLong value: Display boundingBox width * 16r10000 + Display boundingBox height.
	nextPutLong value: 0.  "fullScreenFlag"
	nextPutLong value: Smalltalk vm extraVMMemory.
	byteStream padTo: self imageHeaderSize put: 0.
! !
